## This is the main file for the EES model.
## Howard Perrin 0101187

## Some scout and donald defs to layout the basic GUI
%scout
window main;
display screen;
window main = {
    type: DONALD
    box: [{0, 0}, {500, 500}]
    pict: "BUILDING"
    sensitive: ON
    border: 0
};
display screen = <main>;

%donald
viewport BUILDING
openshape room1
within room1 {
  circle person1
  point origin
  line west, east, south, north
  openshape grid, markers
  person1 = circle(origin + {person1_x! * gridwidth!, person1_y! * gridheight!} - {gridwidth! div 2, gridheight! div 2}, personSize!)
  origin = {room1_origin_x!, room1_origin_y!}
  west = [origin, origin + {0, room1_width!}]
  east = [{room1_width!, 0} + origin, {room1_width!, room1_width!} + origin]
  south = [origin, {room1_width!, 0} + origin]
  north = [{room1_width!, room1_width!} + origin, origin + {0, room1_width!}]
}

%eden
room1_origin_x = 20;
room1_origin_y = 20;
room1_height is 900;
room1_width is 900;
person1_x is 1;
person1_y is 1;
num_cells = 5;
gridheight is room1_height / num_cells;
gridwidth is room1_width / num_cells;
building_height is 1000;
building_width is 1000;
personSize = 10;

##Attribute strings control the colours on the GUI:
attr_unoccupied_cell is "fill=hollow,linewidth=0";
attr_wall_cell is "fill=solid,color=saddlebrown,outlinecolor=saddlebrown";
attr_obs_cell is "fill=solid,color=white,outlinecolor=white";
attr_exit_cell is "fill=solid,color=green,outlinecolor=green";
attr_person is "fill=solid,outlinecolor=black,color=";
attr_person_colour is ["orange","yellow","green","red","black","grey","blue","SlateBlue","Navy","SaddleBrown","peru","pink","azure","cyan","powderblue","gold","ForestGreen","OliveDrab","maroon","violet","AntiqueWhite1","ivory1","wheat","salmon","burlywood","orange","yellow","green","red","black","grey","blue","SlateBlue","Navy","SaddleBrown","peru","pink","azure","cyan","powderblue","gold","ForestGreen","OliveDrab","maroon","violet","AntiqueWhite1","ivory1","wheat","salmon","burlywood","orange","yellow","green","red","black","grey","blue","SlateBlue","Navy","SaddleBrown","peru","pink","azure","cyan","powderblue","gold","ForestGreen","OliveDrab","maroon","violet","AntiqueWhite1","ivory1","wheat","salmon","burlywood","orange","yellow","green","red","black","grey","blue","SlateBlue","Navy","SaddleBrown","peru","pink","azure","cyan","powderblue","gold","ForestGreen","OliveDrab","maroon","violet","AntiqueWhite1","ivory1","wheat","salmon","burlywood","orange","yellow","green","red","black","grey","blue","SlateBlue","Navy","SaddleBrown","peru","pink","azure","cyan","powderblue","gold","ForestGreen","OliveDrab","maroon","violet","AntiqueWhite1","ivory1","wheat","salmon","burlywood"];

##Initial Zero Values:
exittargets = [];
exitsigns = [];
person_positions = [[2,2,2,2,@,@,1]];
number_of_people = 1;
person_movements = [[]];
occupancelist = [[0,0,0,0,0],[0,0,0,0,0],[0,0,0,0,0],[0,0,0,0,0],[0,0,0,0,0]];
wallsquares = [[]];
start_time = @;
end_time = @;
total_time is end_time - start_time -1;
tick = 0;
tickstr is str(tick);

##Called to set the room to a certain grid size. As a side effect, it empties the room.
proc reset_room {
	para newcells;
	auto i, j, occstr;
	occstr = "[";
	i = 1;
	while (i<= newcells) {
		j = 1;
		occstr = occstr // "[";
		while (j<= newcells) {
			occstr = occstr // "0";
			if (j < newcells)	occstr = occstr // ",";
			if (j <= num_cells) execute("%donald\n within /room1/grid {\n rectangle cellh"//str(i)//"v"//str(j)//"\n cellh"//str(i)//"v"//str(j)//" = rectangle({0,0},{0,0})\n}");
			j++;
		}
		occstr = occstr // "]";
		if (i < newcells) occstr = occstr // ",";
		i++;
	}
	occstr = occstr // "];";
	execute("occupancelist is "//occstr);
	num_cells = newcells;
	i = 1;
	while (i<= num_cells) {
		j = 1;
		while (j<= num_cells) {
			execute("%donald\n within /room1/grid {\n rectangle cellh"//str(i)//"v"//str(j)//"\n cellh"//str(i)//"v"//str(j)//" = rectangle(~/origin + {gridwidth! * "//str(i-1)//", gridheight! * "//str(j-1)//"}, ~/origin + {gridwidth! * "//str(i)//", gridheight! * "//str(j)//"} - {2,2})\n}");
			execute("%eden\n A_room1_grid_cellh"//str(i)//"v"//str(j)//" is occupancelist["//str(i)//"]["//str(j)//"]==-1 ? attr_wall_cell : (occupancelist["//str(i)//"]["//str(j)//"]==-2 ? attr_exit_cell : (occupancelist["//str(i)//"]["//str(j)//"]==-3 ? attr_obs_cell : attr_unoccupied_cell));");

			j++;
		}
		i++;
	}
}

##Moves people back to their starting positions.
proc reset_person_positions {
	auto i;
	autocalc = 0;
	for (i=1; i<=person_positions#; i++) {
		person_positions[i][1] = person_positions[i][3];
		person_positions[i][2] = person_positions[i][4];
		person_positions[i][5] = @;
		person_positions[i][6] = @;
	}
	autocalc = 1;
}


NORTH      = 0;
NORTH_EAST = 1;
EAST       = 2;
SOUTH_EAST = 3;
SOUTH      = 4;
SOUTH_WEST = 5;
WEST       = 6;
NORTH_WEST = 7;

## Returns straight line distance between two points.
func distanceBetween {
        para a,b;
        auto xdist, ydist;
        xdist = b[1]-a[1];
        ydist = b[2]-a[2];
        return sqrt(xdist*xdist + ydist*ydist);
}

## Returns a list of all the empty cell surrounding the point given.
## To make people able to move 2 steps at once or diagonally, grow this func.
func whichempty {
	para current;
	auto empties;
	empties = [];
	##writeln(str(occupancelist[current[1]][current[2] + 1]==0));
	if (occupancelist[current[1]][current[2] + 1]==0) append empties, [current[1], current[2] + 1];
	if (occupancelist[current[1]][current[2] - 1]==0) append empties, [current[1], current[2] - 1];
	if (occupancelist[current[1] + 1][current[2]]==0) append empties, [current[1] + 1, current[2]];
	if (occupancelist[current[1] - 1][current[2]]==0) append empties, [current[1] - 1, current[2]];	
	if (occupancelist[current[1]][current[2] + 1]==-2) append empties, [current[1], current[2] + 1];
	if (occupancelist[current[1]][current[2] - 1]==-2) append empties, [current[1], current[2] - 1];
	if (occupancelist[current[1] + 1][current[2]]==-2) append empties, [current[1] + 1, current[2]];
	if (occupancelist[current[1] - 1][current[2]]==-2) append empties, [current[1] - 1, current[2]];	
	return empties;
}

## The core decision-making proc for moving a person.
## Start here when modifying a person's behaviour.
proc moveperson {
	para person_num;
	auto empties, dir, i, closest, closest_dist, current, current_target;
	current = person_positions[person_num];
	current_target = chooseNearestExit(current, getVisibleExits(person_num));
	empties = whichempty(current);
	##writeln(empties#);
	##Unless it's the only option, don't go where we've just been.
	if (empties#>1) {
		for (i=1; i<=empties#; i++) {
			if ((person_movements[person_num]#>0)&&(empties[i]==person_movements[person_num][max(1,person_movements[person_num]#-person_positions[person_num][7]+1)])) {
				delete empties, i;
			}
		}
	}	
	if ((positionIsExit(current)==0)&&(empties#>0)) {
		if ((current_target#==0)) {
			##Can't see any exits so do the headless chicken act ;-)
			closest = empties[1+rnd(empties#-1)];
			##writeln("moving to: "//str(closest));
			append person_movements[person_num], [current[1],current[2]];
			person_positions[person_num][1] = closest[1];
			person_positions[person_num][2] = closest[2];
			updatePeople();
		}	
		else {
			closest = empties[1+rnd(empties#-1)];
			closest_dist = distanceBetween(closest, current_target);
			for (i=1; i<=empties#; i++) {
				if (distanceBetween(empties[i], current_target) < closest_dist) {
					closest = empties[i];
					closest_dist = distanceBetween(empties[i], current_target);
				}
			}
			append person_movements[person_num], [current[1],current[2]];
			person_positions[person_num][1] = closest[1];
			person_positions[person_num][2] = closest[2];
			updatePeople();
		} 
	}
}

## Adds a person at a random position or the position specified.
proc addperson {
	para pos;
	auto cont, position;
	if ($#<1) {
		cont = TRUE;
		while(cont) {
			position = [1+rnd(occupancelist#-1),1+rnd(occupancelist#-1)];
			if (occupancelist[position[1]][position[2]]==0) cont = FALSE;
		}
	} else { position = pos; }
	append person_positions, [position[1],position[2],position[1],position[2],@,@];
}

## Cycles through every person on each tick, giving them a chance to move depending on their speed.
proc movepeople : tick {
	auto i, ae;
	ae = TRUE;
	if (!replaymode&&(tick>0)) {
		for (i=1; i<=person_positions#; i++) {
			if (person_positions[i][5]==@) {
				if (tick%person_positions[i][7]==0) {
					moveperson(i);
				} else {
					append person_movements[i], [person_positions[i][1],person_positions[i][2]];
				}
				ae = FALSE;
			}
		}
		if (ae) {
			pause();
			end_time = tick;
			writeln("Everyone has exited in "//str(total_time/float(ticks_per_sec))//" seconds ("//str(total_time)//" steps)");
			allExited = TRUE;
		}
	}
}
allExited = FALSE;

top_random_speed = 1;
bottom_random_speed = 3;

proc assignrandomspeeds : number_of_people {
	for (i=1; i<=person_positions#; i++) {
		if (person_positions[i]#==4) {
			append person_positions[i], @;
		}
		if (person_positions[i]#==5) {
			append person_positions[i], @;
		}
		if (person_positions[i]#==6) {
			append person_positions[i], (1+rnd(bottom_random_speed-top_random_speed));
		}
	}
}

func chooseNearestExit {
	para current, possibletargets;
	auto closest_dist, closest, i;
	if (possibletargets == []) return possibletargets;
	closest = [possibletargets[1]];
	closest_dist = distanceBetween(current, possibletargets[1]);
	for (i=2; i<=possibletargets#; i++) {
		if (distanceBetween(current, possibletargets[i]) < closest_dist) {
			closest = [possibletargets[i]];
			closest_dist = distanceBetween(current, possibletargets[i]);
		}
		if (distanceBetween(current, possibletargets[i]) == closest_dist) {
			append closest, possibletargets[i];
			closest_dist = distanceBetween(current, possibletargets[i]);
		}
	}
	return closest[1+rnd(closest#-1)];
}

func positionIsExit {
	para curr;
	auto exitctr;
	exitctr=1;
	while (exitctr <= exittargets#) {
		if ((curr[1]==exittargets[exitctr][1])&&(curr[2]==exittargets[exitctr][2])) {
			return exitctr;
		}
		exitctr++;
	}
	return 0;
}

##updates occupancelist when the exit locations change.
proc populateExitsToOccupance : exittargets {
	auto i, j, exitdefstr;
	for (i=1; i<=occupancelist#; i++ ) {
		for (j=1; j<=occupancelist[i]#; j++ ) {
			if (occupancelist[i][j] == -2) occupancelist[i][j] = -1;
		}
	}
	for (i=1; i<=exittargets#; i++ ) {
		occupancelist[exittargets[i][1]][exittargets[i][2]] = -2;
	}
}

number_of_people is person_positions#;
##Maintains the definitions for the exit counters.
proc updateexitctrs : exittargets, number_of_people {
	auto i,j, exitdefstr;
	num_used_exit_1=@;
	num_used_exit_2=@;
	num_used_exit_3=@;
	num_used_exit_4=@;
	num_used_exit_5=@;
	num_used_exit_6=@;
	num_used_exit_7=@;
	num_used_exit_8=@;
	num_used_exit_9=@;
	num_used_exit_10=@;
	for (i=1; i<=exittargets#; i++ ) {
		exitdefstr = "";
		for (j=1; j<=person_positions#; j++) {
			exitdefstr = exitdefstr//"(number_of_people>="//str(j)//" ? person_positions["//str(j)//"][5]=="//str(i)//" : 0)+";
		}
		execute("num_used_exit_"//str(i)//" is "//exitdefstr//"0;");
	}
}

##Maintains a list of grid squares that are walls.
proc populatewallsquares : occupancelist {
	auto i, j;
	wallsquares = [];
	for (i=1; i<=occupancelist#; i++ ) {
		for (j=1; j<=occupancelist[i]#; j++ ) {
			if (occupancelist[i][j] == -1)
				append wallsquares, [i,j];
		}
	}		
}


##Maintains defs related to the people
proc updatePeople : person_positions {
	auto i, j, exited, prevstr;
	if (person_positions_old#!=person_positions#) {
		for (i=1; i<=person_positions#; i++) {
			if (person_movements#<person_positions#) {
				append person_movements, [];
			}
			execute("person"//str(i)//"_x is person_positions#<"//str(i)//" ? -100 : (!replaymode ? person_positions["//str(i)//"][1]:(person_movements["//str(i)//"]#< tick ? -100 :person_movements["//str(i)//"][tick][1]));");
			execute("person"//str(i)//"_y is person_positions#<"//str(i)//" ? -100 : (!replaymode ? person_positions["//str(i)//"][2]:(person_movements["//str(i)//"]#< tick ? -100 :person_movements["//str(i)//"][tick][2]));");
			##execute("person"//str(i)//"_x is person_positions#<"//str(i)//" ? -100 : (person_movements["//str(i)//"]#< tick ? -100 :(replaymode ? person_movements["//str(i)//"][tick][1] : person_positions["//str(i)//"][1]));");
			##execute("person"//str(i)//"_y is person_positions#<"//str(i)//" ? -100 : (person_movements["//str(i)//"]#< tick ? -100 :(replaymode ? person_movements["//str(i)//"][tick][2] : person_positions["//str(i)//"][2]));");
			execute("person"//str(i)//"_abspos is person_positions#<"//str(i)//" ? -1 : [room1_origin_x + ((person_positions["//str(i)//"][1] - 0.5)*gridwidth), room1_origin_y + ((person_positions["//str(i)//"][2] - 0.5)*gridheight)];");
			execute("%donald\n within room1 { \n circle person"//str(i)//"\n person"//str(i)//" = circle(origin + {person"//str(i)//"_x! * gridwidth!, person"//str(i)//"_y! * gridheight!} - {gridwidth! div 2, gridheight! div 2}, personSize!)\n }\n");
			execute(str("A_room1_person")//str(i)//str(" is attr_person//str(attr_person_colour[")//str(i)//"]);");
		}
	}
	if (person_positions_old!=person_positions) {
		##writeln("updating occupance list");
		for (i=1; i<=person_positions_old#; i++) {
			if ((person_positions_old[i][1]!=@)&&(person_positions_old[i][2]!=@)) {
				occupancelist[person_positions_old[i][1]][person_positions_old[i][2]]=0;
			}
		}
		for (i=1; i<=person_positions#; i++) {
			for (j=1; j<=exittargets#; j++) {
				if ((person_positions[i][1]==exittargets[j][1])&&(person_positions[i][2]==exittargets[j][2])) {
					writeln("person "//str(i)//" has gone through exit "//str(j)//" after "//str(tick-start_time)//" steps.");
					person_positions[i][1]=@;
					person_positions[i][2]=@;
					person_positions[i][5]=j;
					person_positions[i][6]=tick-start_time;	
					exited = TRUE;			
				}
			}
			if (!exited) {
				if ((person_positions[i][1]!=@)&&(person_positions[i][2]!=@)) {
						occupancelist[person_positions[i][1]][person_positions[i][2]]=i;
				}
			}
		}
	}
	person_positions_old = person_positions;
}

##Returns all exits that it would be possible to see from the current position.
func getVisibleExits {
	para person_num;
	auto visibleExits, i;
	visibleExits = [];
	for (i=1; i<=exittargets#; i++ ) {
		if (isExitVisible(person_num, exittargets[i])==TRUE) append visibleExits, exittargets[i];
	}
	##writeln("Person: "//str(person_num)//" at: "//str(person_positions[person_num])//" can see exits at: "//str(visibleExits));
	return visibleExits;
}

##Returns TRUE if it is possible to see at least an entire side of an exit from the given position
func isExitVisible {
	para person_num, exittarget;
	auto visiblepoints;
	visiblepoints=[FALSE,FALSE,FALSE,FALSE];
	## Test each corner of the exit rectangle for visibility
	##writeln("For exit "//str(exittarget));
	if (isPointVisible(person_num, [(exittarget[1]-1)*gridwidth+room1_origin_x -2, (exittarget[2]-1)*gridheight+room1_origin_y -2])) visiblepoints[1]=TRUE;
	if (isPointVisible(person_num, [(exittarget[1]-1)*gridwidth+room1_origin_x -2, (exittarget[2])*gridheight+room1_origin_y -2])) visiblepoints[2]=TRUE;
	if (isPointVisible(person_num, [(exittarget[1])*gridwidth+room1_origin_x -2, (exittarget[2])*gridheight+room1_origin_y -2])) visiblepoints[3]=TRUE;
	if (isPointVisible(person_num, [(exittarget[1])*gridwidth+room1_origin_x -2, (exittarget[2]-1)*gridheight+room1_origin_y -2])) visiblepoints[4]=TRUE;
	return 	(visiblepoints[1] && visiblepoints[2])||
			(visiblepoints[2] && visiblepoints[3])||
			(visiblepoints[3] && visiblepoints[4])||
			(visiblepoints[4] && visiblepoints[1]);
}


func isPointVisible {
	para person_num, targetpoint;
	auto currentPos, i, visionXmin, visionXmax, Xmin_is_target, visionYmin, visionYmax, boxXmin, boxXmax, boxYmin, boxYmax;
	currentPos = [room1_origin_x + ((person_positions[person_num][1] - 0.5)*gridwidth), room1_origin_y + ((person_positions[person_num][2] - 0.5)*gridheight)];
	
	##writeln("Testing currentPos: "//str(currentPos)//"against point "//str(targetpoint));
	
	if (currentPos[1]<targetpoint[1]) {
		visionXmin = currentPos[1];
		visionXmax = targetpoint[1];
		Xmin_is_target = FALSE;
	} else {
		visionXmin = targetpoint[1];
		visionXmax = currentPos[1];
		Xmin_is_target = TRUE;
	}
	##Check the vision line against each wall square on the map
	for (i=1; i<=wallsquares#; i++) {
		if (currentPos[2]<targetpoint[2]) {
			visionYmin = currentPos[2];
			visionYmax = targetpoint[2];
			positive_grad = !Xmin_is_target;
		} else {
			visionYmin = targetpoint[2];
			visionYmax = currentPos[2];
			positive_grad = Xmin_is_target;			
		}
		boxXmin = (wallsquares[i][1]-1)*gridwidth + room1_origin_x;
		boxXmax = (wallsquares[i][1])*gridwidth + room1_origin_x -2;
		boxYmin = (wallsquares[i][2]-1)*gridheight + room1_origin_y;
		boxYmax = (wallsquares[i][2])*gridheight + room1_origin_y -2;
		
		if (positive_grad) {
			##writeln("Gradient is positive");
			if (visionXmin<=boxXmin) {
				visionYmin = (boxXmin-visionXmin)*(visionYmax-visionYmin)/(visionXmax-visionXmin) + visionYmin;
			}
			if (visionXmax>=boxXmax) {
				visionYmax = (boxXmax-visionXmin)*(visionYmax-visionYmin)/(visionXmax-visionXmin) + visionYmin;
			}
			if ((visionYmin<boxYmax)&&(visionYmax>boxYmin)) {
				##writeln("   box "//str(wallsquares[i])//" is in the way.");	
				return FALSE;
			}
			##writeln("   box "//str(wallsquares[i])//" is NOT the way.");
		}
		else {
			if (visionXmin<=boxXmin) {
				visionYmax = (boxXmin-visionXmin)*(visionYmin-visionYmax)/(visionXmax-visionXmin) + visionYmax;
			}
			if (visionXmax>=boxXmax) {
				visionYmin = (boxXmax-visionXmin)*(visionYmin-visionYmax)/(visionXmax-visionXmin) + visionYmax;
			}
			if ((visionYmin<boxYmax)&&(visionYmax>boxYmin)) {
				##writeln("   box "//str(wallsquares[i])//" is in the way.");	
				return FALSE;
			}			
		};		
	}
	return TRUE;
}

total_exit_time is allExited ? highestExitTime(person_positions) : "-";
proc highestExitTime {
	para person_positions;
	auto i, highesttime;
	highesttime = person_positions[1][6];
	for (i=1; i<=person_positions#; i++) {
		if (person_positions[i][6]>highesttime) highesttime = person_positions[i][6];
	}
	return highesttime;
}

tickspeed is int(float(1)/float(ticks_per_sec)*1000);
ticks_per_sec is 2;
proc start {
	replaymode is FALSE;
	pauseedenclocks();
	unpauseedenclocks();
	tick = tickpausepoint;
	setedenclock(&tick, tickspeed);
}
	start_time = 0;

proc reset_person_movements {
	auto i;
	autocalc = 0;
	person_movements = [];
	for (i=1; i<=person_positions#; i++) {
		append person_movements, [];
	}
	autocalc = 1;
}

tickpausepoint is 0;
proc pause {
	pauseedenclocks();
	tickpausepoint = tick;
}

proc reset {
	replaymode is FALSE;
	tick = 0;
	tickpausepoint = 0;
	reset_person_positions();
	reset_person_movements();
	selectedperson = @;
}

replaymode is FALSE;
proc replay {
	auto i;
	tick = 1;
	replaymode is TRUE;
	pause();
	unpauseedenclocks();
	setedenclock(&tick, 100);
}

proc longestitem {
	para list;
	auto longestindex, longestlength, i;
	longestindex = 1;
	longestlength = list[1]#;
	for (i=1; i<=list#; i++ ) {
		if (list[i]#>longestlength) {
			longestlength = list[i]#;
			longestindex = i;
		}
	}
	return longestindex;
}

mouse_grid_pos_x is floor((main_mouse[4]-room1_origin_x)/gridwidth+1,1);
mouse_grid_pos_y is floor((main_mouse[5]-room1_origin_y)/gridheight+1,1);
mouse_grid_value is occupancelist[mouse_grid_pos_x][mouse_grid_pos_y];

proc mouse_listener : main_mouse {
	auto exitnum;	
	if (main_mouse[2]==4) {
		if (main_mouse[1]==1) {
			if (mouse_grid_value<=0) {
			  	if (mouse_grid_value==-1)
			  	  occupancelist[mouse_grid_pos_x][mouse_grid_pos_y] = 0;
			  	else if (mouse_grid_value==0)
			  	  occupancelist[mouse_grid_pos_x][mouse_grid_pos_y] = -3;
			  	else if (mouse_grid_value==-3)
			  	  occupancelist[mouse_grid_pos_x][mouse_grid_pos_y] = -1;			  	  
			} else {
				mouse_moving_person = mouse_grid_value;
				selectedperson = mouse_grid_value;
			}
		}
		if (main_mouse[1]==3) {
			exitnum = positionIsExit([mouse_grid_pos_x,mouse_grid_pos_y]);
			if (exitnum>0) 
				delete exittargets, exitnum;
			else 
				append exittargets, [mouse_grid_pos_x,mouse_grid_pos_y];
	  	}
	}
	if ((main_mouse[2]==5)&&(mouse_moving_person>0)) {
		person_positions[mouse_moving_person][1] = mouse_grid_pos_x;
		person_positions[mouse_moving_person][2] = mouse_grid_pos_y;	
		if ((main_mouse[3]-4!=256)&&(main_mouse[3]-4!=272)) {
			person_positions[mouse_moving_person][3] = mouse_grid_pos_x;
			person_positions[mouse_moving_person][4] = mouse_grid_pos_y;
		}	
		mouse_moving_person = 0;
		
	}
}

room_file_output is "reset_room("//str(num_cells)//");\n autocalc=0;\n occupancelist="//str(occupancelist)//";\n person_positions="//str(person_positions)//";\n exittargets="//str(exittargets)//";\n updateexitctrs();\n autocalc=1;\n reset_person_movements();";


##Function which computes the cell attribute values.
func cellAttributes {
	para ref;
	if (occupancelist[ref[1]][ref[2]]==-1)
			return attr_wall_cell;
	if (occupancelist[ref[1]][ref[2]]==0)
			return attr_unoccupied_cell;
	if (occupancelist[ref[1]][ref[2]]==-2)
			return attr_exit_cell;
}
